unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, Buttons, LanguageObjects, LanguageIcons;

type
  TfrmMain = class(TForm)
    grpMain: TGroupBox;
    lblEdit: TLabel;
    txtEdit: TEdit;
    lstHasiputz: TComboBox;
    btnExit: TBitBtn;
    lstLanguages: TComboBoxEx;
    lblHasiputz: TLabel;
    lblLanguages: TLabel;
    lblMemo: TLabel;
    txtMemo: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure lstLanguagesChange(Sender: TObject);
    procedure btnExitClick(Sender: TObject);
  private
    LanguageIcons: TLanguageIcons;

    procedure PreTranslate;
    procedure PostTranslate;
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

{$R *.dfm}
{$I strings.inc}

{ TForm1 }

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  // Needed things
  LanguageIcons := TLanguageIcons.Create;

  // Translate form, call PreTranslate and PostTranslate
  Language.Translate(Self, PreTranslate, PostTranslate);
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  LanguageIcons.Free;
end;

procedure TfrmMain.lstLanguagesChange(Sender: TObject);
begin
  if lstLanguages.ItemIndex > -1 then
  begin
    Language.CurrentLanguage := TLanguage(lstLanguages.ItemsEx[lstLanguages.ItemIndex].Data);
    Language.Translate(Self, PreTranslate, PostTranslate);
  end;
end;

procedure TfrmMain.btnExitClick(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.PreTranslate;
begin

end;

procedure TfrmMain.PostTranslate;
var
  i: Integer;
  ComboItem: TComboExItem;
begin
  lstLanguages.Clear;
  lstLanguages.Images := LanguageIcons.List;
  for i := 0 to LanguageList.Count - 1 do
    if LanguageList[i].Available then
    begin
      ComboItem := lstLanguages.ItemsEx.Add;
      ComboItem.Caption := LanguageList[i].Name;
      ComboItem.Data := LanguageList[i];
      ComboItem.ImageIndex := LanguageIcons.GetIconIndex(LanguageList[i].ID);
      if Language.CurrentLanguage.ID = LanguageList[i].ID then
        lstLanguages.ItemIndex := ComboItem.Index;
    end;
  txtMemo.Text := _(rsTest);
end;

end.
